
//
// Academic License - for use in teaching, academic research, and meeting
// course requirements at degree granting institutions only.  Not for
// government, commercial, or other organizational use.
// File: kin_xyzbc_tt_JP_jt.cpp
//
// MATLAB Coder version            : 5.4
//

// Include Files
#include "kin_xyzbc_tt_JP_jt.h"
#include "coder_array.h"
#include <cmath>

// Function Definitions
//
// function JP_jt = kin_xyzbc_tt_JP_jt(in1,in2,in3)
//
// kin_xyzbc_tt_JP_jt
//     JP_jt = kin_xyzbc_tt_JP_jt(IN1,IN2,IN3)
//
// Arguments    : const ::coder::array<double, 1U> &in1
//                const ::coder::array<double, 1U> &in2
//                const ::coder::array<double, 1U> &in3
//                double JP_jt[5][5]
// Return Type  : void
//
namespace ocn {
void kin_xyzbc_tt_JP_jt(const ::coder::array<double, 1U> &in1,
                        const ::coder::array<double, 1U> &in2,
                        const ::coder::array<double, 1U> &in3, double JP_jt[5][5])
{
    double b_t3[25];
    double b_t3_tmp;
    double t12;
    double t13_tmp;
    double t16;
    double t17_tmp;
    double t2;
    double t20;
    double t20_tmp;
    double t21_tmp;
    double t24;
    double t24_tmp;
    double t27;
    double t28;
    double t28_tmp;
    double t3;
    double t3_tmp;
    double t4;
    double t5;
    double t6;
    double t7;
    double t8;
    double t9_tmp;
    //     This function was generated by the Symbolic Math Toolbox version 9.1.
    //     07-Nov-2023 14:54:35
    // Jacobian first derivative ( Inverse Kinematics ) :
    // INPUTS :
    // 	r_t    (5x1) : pose vector ( piece frame )
    // 	v_t    (5x1) : speed vector ( piece frame )
    // 	a_t    (5x1) : acceleration vector( piece frame )
    // 	p      (3x5) : parameters
    // OUTPUTS :
    // 	M      (5x5) : resulting matrix
    // 'kin_xyzbc_tt_JP_jt:17' b = in1(4,:);
    // 'kin_xyzbc_tt_JP_jt:18' c = in1(5,:);
    // 'kin_xyzbc_tt_JP_jt:19' offB1 = in3(10);
    // 'kin_xyzbc_tt_JP_jt:20' offC1 = in3(13);
    // 'kin_xyzbc_tt_JP_jt:21' offB3 = in3(12);
    // 'kin_xyzbc_tt_JP_jt:22' offC2 = in3(14);
    // 'kin_xyzbc_tt_JP_jt:23' offC3 = in3(15);
    // 'kin_xyzbc_tt_JP_jt:24' offP1 = in3(7);
    // 'kin_xyzbc_tt_JP_jt:25' offP2 = in3(8);
    // 'kin_xyzbc_tt_JP_jt:26' offP3 = in3(9);
    // 'kin_xyzbc_tt_JP_jt:27' tp1 = in2(1,:);
    // 'kin_xyzbc_tt_JP_jt:28' tp2 = in2(2,:);
    // 'kin_xyzbc_tt_JP_jt:29' tp3 = in2(3,:);
    // 'kin_xyzbc_tt_JP_jt:30' tp4 = in2(4,:);
    // 'kin_xyzbc_tt_JP_jt:31' tp5 = in2(5,:);
    // 'kin_xyzbc_tt_JP_jt:32' x = in1(1,:);
    // 'kin_xyzbc_tt_JP_jt:33' y = in1(2,:);
    // 'kin_xyzbc_tt_JP_jt:34' z = in1(3,:);
    // 'kin_xyzbc_tt_JP_jt:35' t2 = cos(b);
    t2 = std::cos(in1[3]);
    // 'kin_xyzbc_tt_JP_jt:36' t3 = cos(c);
    t3 = std::cos(in1[4]);
    // 'kin_xyzbc_tt_JP_jt:37' t4 = sin(b);
    t4 = std::sin(in1[3]);
    // 'kin_xyzbc_tt_JP_jt:38' t5 = sin(c);
    t5 = std::sin(in1[4]);
    // 'kin_xyzbc_tt_JP_jt:39' t6 = offP1+x;
    t6 = in1[0] + in3[6];
    // 'kin_xyzbc_tt_JP_jt:40' t7 = offP2+y;
    t7 = in1[1] + in3[7];
    // 'kin_xyzbc_tt_JP_jt:41' t8 = offP3+z;
    t8 = in1[2] + in3[8];
    // 'kin_xyzbc_tt_JP_jt:42' t9 = offC1.*t2.*t3;
    t9_tmp = in3[12] * t2;
    // 'kin_xyzbc_tt_JP_jt:43' t10 = offC2.*t2.*t3;
    // 'kin_xyzbc_tt_JP_jt:44' t11 = offC1.*t2.*t5;
    // 'kin_xyzbc_tt_JP_jt:45' t12 = offC1.*t3.*t4;
    t12 = in3[12] * t3 * t4;
    // 'kin_xyzbc_tt_JP_jt:46' t13 = offC2.*t2.*t5;
    t13_tmp = in3[13] * t2;
    // 'kin_xyzbc_tt_JP_jt:47' t14 = offC2.*t3.*t4;
    // 'kin_xyzbc_tt_JP_jt:48' t15 = offC1.*t4.*t5;
    // 'kin_xyzbc_tt_JP_jt:49' t16 = offC2.*t4.*t5;
    t16 = in3[13] * t4 * t5;
    // 'kin_xyzbc_tt_JP_jt:50' t17 = t2.*t3.*t6;
    t17_tmp = t2 * t3;
    // 'kin_xyzbc_tt_JP_jt:51' t18 = t2.*t3.*t7;
    // 'kin_xyzbc_tt_JP_jt:52' t19 = t2.*t5.*t6;
    // 'kin_xyzbc_tt_JP_jt:53' t20 = t3.*t4.*t6;
    t20_tmp = t3 * t4;
    t20 = t20_tmp * t6;
    // 'kin_xyzbc_tt_JP_jt:54' t21 = t2.*t5.*t7;
    t21_tmp = t2 * t5;
    // 'kin_xyzbc_tt_JP_jt:55' t22 = t3.*t4.*t7;
    // 'kin_xyzbc_tt_JP_jt:56' t23 = t4.*t5.*t6;
    // 'kin_xyzbc_tt_JP_jt:57' t24 = t4.*t5.*t7;
    t24_tmp = t4 * t5;
    t24 = t24_tmp * t7;
    // 'kin_xyzbc_tt_JP_jt:58' t25 = -t13;
    // 'kin_xyzbc_tt_JP_jt:59' t26 = -t21;
    // 'kin_xyzbc_tt_JP_jt:60' t27 = t10+t11+t18+t19;
    t27 = ((t13_tmp * t3 + t9_tmp * t5) + t17_tmp * t7) + t21_tmp * t6;
    // 'kin_xyzbc_tt_JP_jt:61' t28 = t14+t15+t22+t23;
    t28_tmp = in3[13] * t3;
    t28 = ((t28_tmp * t4 + in3[12] * t4 * t5) + t20_tmp * t7) + t24_tmp * t6;
    // 'kin_xyzbc_tt_JP_jt:62' mt1 =
    // [-t3.*t4.*tp4-t2.*t5.*tp5,t3.*tp5,-t2.*t3.*tp4+t4.*t5.*tp5,0.0,0.0,-t2.*t3.*tp5+t4.*t5.*tp4,-t5.*tp5,t2.*t5.*tp4+t3.*t4.*tp5,0.0,0.0,t2.*tp4,0.0,-t4.*tp4,0.0,0.0,-tp4.*(t9+t17+t25+t26+offB1.*t2+offB3.*t4+offC3.*t4+t4.*t8)+t2.*tp3+t28.*tp5-t3.*t4.*tp1+t4.*t5.*tp2,0.0,-t4.*tp3+t27.*tp5-tp4.*(-t12+t16-t20+t24-offB1.*t4+offB3.*t2+offC3.*t2+t2.*t8)-t2.*t3.*tp1+t2.*t5.*tp2,0.0,0.0,-tp5.*(t9+t17+t25+t26)+t28.*tp4-t2.*t3.*tp2-t2.*t5.*tp1];
    // 'kin_xyzbc_tt_JP_jt:63' mt2 =
    // [-tp5.*(offC2.*t3+offC1.*t5+t3.*t7+t5.*t6)+t3.*tp1-t5.*tp2,t27.*tp4+tp5.*(t12-t16+t20-t24)+t3.*t4.*tp2+t4.*t5.*tp1,0.0,0.0];
    // 'kin_xyzbc_tt_JP_jt:64' JP_jt = reshape([mt1,mt2],5,5);
    b_t3[0] = -t3 * t4 * in2[3] - t21_tmp * in2[4];
    b_t3[1] = t3 * in2[4];
    t3_tmp = -t2 * t3;
    b_t3[2] = t3_tmp * in2[3] + t24_tmp * in2[4];
    b_t3[3] = 0.0;
    b_t3[4] = 0.0;
    b_t3[5] = t3_tmp * in2[4] + t24_tmp * in2[3];
    b_t3[6] = -t5 * in2[4];
    b_t3[7] = t21_tmp * in2[3] + t20_tmp * in2[4];
    b_t3[8] = 0.0;
    b_t3[9] = 0.0;
    b_t3[10] = t2 * in2[3];
    b_t3[11] = 0.0;
    b_t3[12] = -t4 * in2[3];
    b_t3[13] = 0.0;
    b_t3[14] = 0.0;
    b_t3_tmp = ((t9_tmp * t3 + t17_tmp * t6) + -(t13_tmp * t5)) + -(t21_tmp * t7);
    b_t3[15] = (((-in2[3] * ((((b_t3_tmp + in3[9] * t2) + in3[11] * t4) + in3[14] * t4) + t4 * t8) +
                  t2 * in2[2]) +
                 t28 * in2[4]) -
                t20_tmp * in2[0]) +
               t24_tmp * in2[1];
    b_t3[16] = 0.0;
    b_t3[17] =
        (((-t4 * in2[2] + t27 * in2[4]) -
          in2[3] * (((((((-t12 + t16) - t20) + t24) - in3[9] * t4) + in3[11] * t2) + in3[14] * t2) +
                    t2 * t8)) -
         t17_tmp * in2[0]) +
        t21_tmp * in2[1];
    b_t3[18] = 0.0;
    b_t3[19] = 0.0;
    b_t3[20] = ((-in2[4] * b_t3_tmp + t28 * in2[3]) - t17_tmp * in2[1]) - t21_tmp * in2[0];
    b_t3[21] =
        (-in2[4] * (((t28_tmp + in3[12] * t5) + t3 * t7) + t5 * t6) + t3 * in2[0]) - t5 * in2[1];
    b_t3[22] = ((t27 * in2[3] + in2[4] * (((t12 - t16) + t20) - t24)) + t20_tmp * in2[1]) +
               t24_tmp * in2[0];
    b_t3[23] = 0.0;
    b_t3[24] = 0.0;
    for (int i{0}; i < 5; i++) {
        for (int i1{0}; i1 < 5; i1++) {
            JP_jt[i][i1] = b_t3[i1 + 5 * i];
        }
    }
}

} // namespace ocn

//
// File trailer for kin_xyzbc_tt_JP_jt.cpp
//
// [EOF]
//
